<template>
  <div class="app-container">
    <el-card>
      <el-form
        :model="queryParams"
        ref="queryForm"
        size="small"
        :inline="true"
        v-show="showSearch"
        label-width="88px"
      >
        <el-form-item label="消毒日期" prop="timeRange">
          <el-date-picker
            v-model="queryParams.timeRange"
            type="daterange"
            value-format="yyyy-MM-dd"
            range-separator="至"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            :picker-options="pickerOptions"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="消毒位置" prop="disinfectLocation">
          <el-select v-model="queryParams.disinfectLocation">
            <el-option
              v-for="(item, i) in locationList"
              :key="i"
              :label="item.locationName"
              :value="item.locationName"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:degass:add']"
            >新增</el-button
          >
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['app:degass:remove']"
            >删除</el-button
          >
        </el-col>
        <right-toolbar
          :showSearch.sync="showSearch"
          @queryTable="getList"
        ></right-toolbar>
      </el-row>
    </el-card>
    <br />
    <el-card>
      <el-table
        border
        stripe
        v-loading="loading"
        height="600"
        ref="multipleTable"
        :data="disposalList"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55" />
        <!--       <el-table-column label="ID"  prop="id" width="80" />  -->
        <el-table-column label="消毒日期" prop="disinfectTime" />
        <el-table-column label="消毒位置" prop="disinfectLocation" />
        <el-table-column label="待宰圈号" prop="pigpenName" />
        <el-table-column label="车辆号码" prop="car" />
        <el-table-column label="消毒方式" prop="disinfectMethod" />
        <el-table-column label="消毒药物及说明" prop="disinfectDose" />
        <el-table-column label="消毒人员" prop="disinfectUser" />
        <el-table-column label="备注" prop="remark" />
        <el-table-column
          label="操作"
          width="180"
          class-name="small-padding fixed-width"
        >
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
              >查看</el-button
            >
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:degass:edit']"
              style="margin-right: 10px"
              >修改</el-button
            >
            <el-popconfirm
              v-hasPermi="['app:degass:remove']"
              :title="'是否确认删除所选数据项？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
                >删除</el-button
              >
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total > 0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form
        ref="form"
        label-position="left"
        :model="form"
        :rules="rules"
        :disabled="isView"
        label-width="140px"
      >
        <el-form-item label="消毒日期" prop="disinfectTime">
          <el-date-picker
            v-model="form.disinfectTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择日期时间"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="消毒位置" prop="disinfectLocation">
          <el-select v-model="form.disinfectLocation">
            <el-option
              v-for="(item, i) in locationList"
              :key="i"
              :label="item.locationName"
              :value="item.locationName"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item
          v-if="form.disinfectLocation === '待宰间'"
          label="待宰圈号"
          prop="pigpenNameArr"
        >
          <div class="flex-area">
            <el-select
              v-model="form.pigpenNameArr"
              multiple
              collapse-tags

            >
              <el-option
                v-for="item in pigpenList"
                :key="item.id"
                :value="item.pigpenName"
                :label="item.pigpenName"
              ></el-option>
            </el-select>
            <el-checkbox
              v-model="checkAllPigpen"
              style="margin-left: 10px"
              @change="checkAll"
              >全选</el-checkbox
            >
          </div>
        </el-form-item>
        <el-form-item
          v-if="form.disinfectLocation === '车辆'"
          label="车辆号码"
          prop="car"
        >
          <el-select v-model="form.car" placeholder="请选择车辆号码" filterable
                     allow-create>
            <el-option v-for="(item, i) in carList" :key="i" :value="item.carNum" :label="item.carNum"></el-option>
          </el-select>
<!--          <el-input v-model="form.car" placeholder="请输入车辆号码"></el-input>-->
        </el-form-item>
        <el-form-item label="消毒方式" prop="disinfectMethod">
          <el-select v-model="form.disinfectMethod">
            <el-option
              v-for="(item, i) in disinfectList"
              :key="i"
              :label="item.disinfectMethod"
              :value="item.disinfectMethod"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="消毒药物及说明" prop="disinfectDose">
          <el-input
            v-model="form.disinfectDose"
            type="textarea"
            :autosize="{ minRows: 2 }"
            disabled
            placeholder="选择消毒方式自动填充"
          ></el-input>
        </el-form-item>
        <el-form-item label="消毒人员" prop="disinfectUser">
          <el-input
            v-model="form.disinfectUser"
            show-word-limit
            maxlength="10"
            placeholder="请输入消毒人员"
          ></el-input>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            type="textarea"
            :autosize="{ minRows: 2 }"
            v-model="form.remark"
            maxlength="50"
            show-word-limit
            :placeholder="isView ? '' : '请输入备注'"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import {
  getDegassPage,
  getDegassDetail,
  addDegassPage,
  editDegassPage,
  delDegassPage,
} from "../../../api/app/degass";
import { getDegassLocationList } from "../../../api/app/degassLocation";
import { formatDate, getFindByKey } from "../../../utils";
import { getAllPigpen } from "../../../api/app/pigpen";
import { getDisinfectList } from "../../../api/app/disinfect";
import { required, rules } from "../../../utils/formRules";
import { getUserProfile } from "../../../api/system/user";
import {listEntranceBatchAll} from "../../../api/app/entranceBatch";

export default {
  name: "",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView: false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        disinfectLocation: null,
        startTime: null,
        endTime: null,
      },
      pickerOptions: {
        disabledDate(time) {
          // 获取当前日期
          const today = new Date();
          today.setHours(0, 0, 0, 0); // 将时间设置为当天的 00:00:00

          // 禁用今天之后的日期
          return time.getTime() > today.getTime();
        },
      },
      // 待宰圈号
      pigpenList: [],
      // 消毒位置
      locationList: [],
      // 消毒方式
      disinfectList: [],
      //全选待宰圈标记
      checkAllPigpen: false,
      // 表单参数
      form: {
        id: null,
        car: null,
        disinfectDose: null,
        disinfectLocation: null,
        disinfectMethod: null,
        disinfectTime: formatDate(new Date()),
        disinfectUser: null,
        pigpenName: null,
        pigpenNameArr: null,
        remark: null,
      },
      rules: {
        disinfectTime: [required("消毒时间不能为空")],
        disinfectLocation: [required("消毒位置不能为空")],
        pigpenNameArr: [required("待宰圈号不能为空")],
        car: [required("车辆号码不能为空"), rules.carNum],
        disinfectMethod: [required("消毒方式不能为空")],
        disinfectDose: [required("消毒药物及说明不能为空")],
        disinfectUser: [required("消毒人员不能为空")],
      },
      user: {},
      carList: [],
    };
  },
  watch: {
    "queryParams.timeRange": {
      handler(newVal) {
        if (newVal) {
          this.queryParams.startTime = newVal[0];
          this.queryParams.endTime = newVal[1];
        } else {
          this.queryParams.startTime = null;
          this.queryParams.endTime = null;
        }
      },
      deep: true,
    },
    "form.pigpenNameArr": {
      handler(newVal) {
        //const allValues = this.pigpenList.map((opt) => opt.value);
        if(newVal){
          if (newVal.length === 0) {
            this.checkAllPigpen = false;
          } else if (newVal.length === this.pigpenList.length) {
            this.checkAllPigpen = true;
          } else {
            this.checkAllPigpen = false;
          }
        }else{
          this.checkAllPigpen = false;
        }

      },
      immediate: true,
    },
    "form.disinfectMethod": {
      handler(newVal) {
        if (newVal) {
          let item = getFindByKey(
            this.disinfectList,
            newVal,
            "disinfectMethod"
          );
          if (item) {
            this.form.disinfectDose = item.disinfectDose;
          }
        } else {
          this.form.disinfectDose = null;
        }
      },
      deep: true,
    },
    "form.disinfectLocation": {
      handler(newVal) {
        if(newVal === '车辆') {
          this.getCar()
        }
      },
      deep: true
    }
  },
  created() {
    this.loading = false
    this.getLocation()
    this.getUser();
    this.getDisinfect();
    this.getPigpen();
    this.getList();
  },
  methods: {
    /** 拿到车辆 **/
    getCar() {
      let params = {
        entranceTime: formatDate(new Date().getTime() - 1000*60 * 60 * 24 * 2)
      }
      listEntranceBatchAll(params).then(res => {
        this.carList = res.rows
      })
    },
    // 消毒点位
    getLocation() {
      getDegassLocationList({}).then(res => {
        this.locationList = res.data
      })
    },
    //全选待宰圈
    checkAll() {
      this.form.pigpenNameArr = [];
      if (this.checkAllPigpen) {
        this.pigpenList.forEach((item) => {
          this.form.pigpenNameArr.push(item.pigpenName);
        });
      } else {
        this.form.pigpenNameArr = [];
      }
    },
    /** getUser **/
    getUser() {
      getUserProfile().then((response) => {
        this.user = response.data;
        this.form.disinfectUser = response.data.nickName;
      });
    },
    /** 消毒方式 **/
    getDisinfect() {
      getDisinfectList().then((res) => {
        this.disinfectList = res.data;
      });
    },
    /** 待宰圈号 **/
    getPigpen() {
      getAllPigpen().then((res) => {
        this.pigpenList = res.data;
      });
    },
    /** 查询检验项目列表 */
    getList() {
      getDegassPage(this.queryParams).then((res) => {
        this.disposalList = res.data.records;
        this.total = res.data.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        timeRange: null,
        disinfectLocation: null,
        startTime: null,
        endTime: null,
      };
      // this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.disinfectList.forEach((item) => {
        if (item.defaultFlag) {
          this.form.disinfectMethod = item.disinfectMethod;
          this.form.disinfectDose = item.disinfectDose;
        }
      });
      this.isView = false;
      this.title = "添加消毒登记";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id,
      };
      getDegassDetail(params).then((res) => {
        this.form = res.data;
        if (this.form.disinfectLocation === "待宰间" && this.form.pigpenName) {
          this.$set(this.form, "pigpenNameArr", this.form.pigpenName.split(","));
          if (this.form.pigpenNameArr.length == this.pigpenList.length) {
            this.checkAllPigpen = true;
          } else {
            this.checkAllPigpen = false;
          }
        } else {
          this.$set(this.form, "pigpenNameArr", []);
        }

        this.open = true;
        this.isView = false;
        this.title = "修改消毒登记";
      });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id,
      };
      getDegassDetail(params).then((res) => {
        this.form = res.data;
        if (this.form.disinfectLocation === "待宰间" && this.form.pigpenName) {
          this.$set(this.form, "pigpenNameArr", this.form.pigpenName.split(","));
          if (this.form.pigpenNameArr.length == this.pigpenList.length) {
            this.checkAllPigpen = true;
          } else {
            this.checkAllPigpen = false;
          }
        } else {
          this.$set(this.form, "pigpenNameArr", []);
        }

        this.open = true;
        this.isView = true;
        this.title = "查看消毒登记";
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        car: null,
        disinfectDose: null,
        disinfectLocation: null,
        disinfectMethod: null,
        disinfectTime: formatDate(new Date()),
        disinfectUser: this.user.nickName,
        pigpenName: null,
        remark: null,
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.disinfectLocation === "待宰间") {
            this.form.pigpenName = this.form.pigpenNameArr
              ? this.form.pigpenNameArr.join(",")
              : "";
          } else {
            this.form.pigpenName = "";
          }
          if (this.form.id != null) {
            // 编辑
            editDegassPage(this.form).then((res) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // 新增
            addDegassPage(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids,
      };
      delDegassPage(params).then((res) => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      });
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm("是否确认删除所选数据项？").then(() => {
        let params = {
          ids: ids.join(","),
        };
        delDegassPage(params).then((res) => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        });
      });
    },
  },
};
</script>

<style scoped lang="scss">
.flex-area {
  display: flex;
  align-items: center;
}
</style>
